#pragma once

#include "MenuLib.h"

/* ASCII codes for standard command key equivalents */
#define undoKey			'z'
#define cutKey				'x'
#define copyKey			'c'
#define pasteKey			'v'
#define cancelKey			'.'

/* ASCII codes of some keys */
#define backspaceKey		'\b'
#define tabKey				'\t'
#define returnKey			'\r'
#define enterKey			(0x03)
#define clearKey			(0x1B)
#define arrowLeftKey		(0x1C)
#define arrowRightKey	(0x1D)
#define arrowUpKey		(0x1E)
#define arrowDownKey		(0x1F)

/* key codes of some keys */
#define commandKeyCode	(55)
#define shiftKeyCode		(56)
#define optionKeyCode	(58)

/* virtual key codes for extended keyboards (IM-V, p192) */
#define escapeVKey		(0x35)
#define undoVFKey			(0x7A)
#define cutVFKey			(0x78)
#define copyVFKey			(0x63)
#define pasteVFKey		(0x76)
#define helpVKey			(0x72)
#define pageUpVKey		(0x74)
#define pageDownVKey		(0x79)
#define homeVKey			(0x73)
#define endVKey			(0x77)
#define fwdDelVKey		(0x75)

Boolean KeyIsDown(unsigned char key);
Boolean KeyIsArrow(unsigned char key);

unsigned char KeyVirtual(EventRecord *event);
MenuCommandType KeyToCmd(EventRecord *event);
Boolean KeyCancel(EventRecord *event);
Boolean KeyArrow(EventRecord *event);
Boolean KeyMovement(EventRecord *event);
Boolean KeyCmd(EventRecord *event);
Boolean KeyCmdDlg(EventRecord *event);
Boolean KeyCmdDlgModal(EventRecord *event);
